<?php
namespace Drupal\test_by_contenttype;

use DOMDocument;
use Drupal\test_by_contenttype\Curler;

/**
 * Test class to extend
 *
 * PHP version 7
 *
 * 
 * @category HTML
 * @package  TestByContenttype
 * @author   Zef Oudendorp <zef@kees-tm.nl>
 * @license  MIT
 * @link     https://packagist.org/packages/keestm/test-by-contenttype
 */
class Test
{
    /**
     * Get DOM object & HTML source!
     *
     * @param string $domain of the site we'r e on
     * @param string $test_uri of the page we're on
     * @param string $html_source of the page we're on, will be given a value inside this function!
     *
     * @return object domObject of the page we're on
     */
    public function _getDomObj($domain, $test_uri, &$html_source)
    {
        //Is this URL available?
        if ($this->_isDeadLink($domain, $test_uri)) {
            return false;
        } else {
            $curler = new Curler();
            $html_source = $curler->do($domain.$test_uri, false);
            libxml_use_internal_errors(true);
            $dom_obj = new DOMDocument();
            $dom_obj->loadHTML($html_source);
            return $dom_obj;
        }
    }

    /**
     * Check if the link returns header 200, 301 or 302
     *
     * @param string $domain of the site we're on
     * @param string $url of the link which we're about to check
     *
     * @return boolean
     *
     */
    public function _isDeadLink($domain, $url)
    {
        //Check if it's a  local or remote (or even protocol relative!) URL so we can see if the content actually exists
        $curler = new Curler();
        $url = (strstr($url, "http")? "": (preg_match("#^\/\/#", $url)? "https:": $domain)).$url;
        $http_status = $curler->do($url, false, true);
        return false;
        if (!in_array($http_status, ["200", "301", "302"])) {
            return true;
        } else {
            return false;
        }
    }
}